Imports Syncfusion.Windows.Forms.Grid

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents GridControl1 As Syncfusion.Windows.Forms.Grid.GridControl
    Friend WithEvents DataGrid1 As System.Windows.Forms.DataGrid
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.GridControl1 = New Syncfusion.Windows.Forms.Grid.GridControl()
        Me.DataGrid1 = New System.Windows.Forms.DataGrid()
        CType(Me.GridControl1, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'GridControl1
        '
        Me.GridControl1.AllowDrop = True
        Me.GridControl1.Anchor = ((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.GridControl1.Location = New System.Drawing.Point(32, 16)
        Me.GridControl1.Name = "GridControl1"
        Me.GridControl1.Size = New System.Drawing.Size(352, 144)
        Me.GridControl1.TabIndex = 0
        Me.GridControl1.Text = "GridControl1"
        '
        'DataGrid1
        '
        Me.DataGrid1.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.DataGrid1.DataMember = ""
        Me.DataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText
        Me.DataGrid1.Location = New System.Drawing.Point(32, 176)
        Me.DataGrid1.Name = "DataGrid1"
        Me.DataGrid1.Size = New System.Drawing.Size(368, 120)
        Me.DataGrid1.TabIndex = 1
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(440, 317)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.DataGrid1, Me.GridControl1})
        Me.Name = "Form1"
        Me.Text = "Form1"
        CType(Me.GridControl1, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'just set up a table somehow
        Dim dt As New DataTable("MyTable")
        Dim nCols As Integer = 4
        Dim nRows As Integer = 10
        Dim i As Integer
        Dim j As Integer
        For i = 0 To nCols - 1
            dt.Columns.Add(New DataColumn(String.Format("Col{0}", i)))
        Next
        For i = 0 To nRows - 1
            Dim dr As DataRow = dt.NewRow()
            For j = 0 To nCols - 1
                dr(j) = String.Format("row{0} col{1}", i, j)
            Next
            dt.Rows.Add(dr)
        Next

        Me.DataGrid1.DataSource = dt

        'register custom drop object with the grid....
        Me.GridControl1.RegisterDataObjectConsumer(New MyDataObjectConsumer(Me.GridControl1))

    End Sub

    'handled to start drop from the DataTable
    Private Sub DataGrid1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles DataGrid1.MouseDown

        Dim hti As DataGrid.HitTestInfo = Me.DataGrid1.HitTest(New Point(e.X, e.Y))
        If hti.Type = DataGrid.HitTestType.RowHeader Then
            Dim dt As DataTable = Me.DataGrid1.DataSource ' this is a datatable
            Dim data As New DataObject("DataRow", dt.Rows(hti.Row))

            DoDragDrop(data, DragDropEffects.All)
        End If
		
    End Sub

    
End Class


' needs Name, QueryAcceptData, DetermineRowColCount, DropAtRowCol to implement IGridDataObjectConsumer
Public Class MyDataObjectConsumer
    Implements IGridDataObjectConsumer

    Private grid As GridControlBase

    Public Sub New(ByVal gridBase As GridControlBase)
        MyBase.New()
        grid = gridBase
    End Sub

    'name for the data type
    Public Overridable Overloads ReadOnly Property Name() As String Implements IGridDataObjectConsumer.Name
        Get
            Return "DataRow"
        End Get

    End Property

    ' checks if proper data available in the dataObject
    Public Overridable Overloads Function QueryAcceptData(ByVal dataObject As IDataObject, ByVal consumer As IGridDataObjectConsumer, ByVal options As GridQueryAcceptDataOptions) As Boolean Implements IGridDataObjectConsumer.QueryAcceptData
        Dim b As Boolean = dataObject.GetDataPresent(Me.Name)
         Return dataObject.GetDataPresent(Me.Name)
    End Function

    'used to draw the target rectangle
    Overridable Overloads Function DetermineRowColCount(ByVal dataObject As IDataObject) As Size Implements IGridDataObjectConsumer.DetermineRowColCount
        Dim rowCount As Integer = 0
        Dim colCount As Integer = 0
        If dataObject.GetDataPresent(Me.Name) Then
            Try
                Dim dr As DataRow = CType(dataObject.GetData(Me.Name), DataRow)
                rowCount = 1
                colCount = dr.Table.Columns.Count
            Catch

            End Try

        End If

        Return New Size(colCount, rowCount)
    End Function

    'puts the data into the GridControl
    Public Overridable Overloads Function DropAtRowCol(ByVal dataObject As IDataObject, ByVal rowIndex As Integer, ByVal colIndex As Integer) As Boolean Implements IGridDataObjectConsumer.DropAtRowCol
        If dataObject.GetDataPresent(Me.Name) Then
            Try
                Dim dr As DataRow = CType(dataObject.GetData(Me.Name), DataRow)
                Dim rowCount As Integer = 1
                Dim colCount As Integer = dr.ItemArray.GetLowerBound(0)
                Dim i As Integer
                Dim j As Integer = 0
                For i = colIndex To Math.Max(grid.Model.ColCount, colIndex + colCount)
                    grid.Model(rowIndex, i).CellValue = dr(j)
                    j += 1
                Next
                Return True
            Catch

            End Try
            Return False
        End If

    End Function

End Class
